//
// IFSCEventListener.aidl
//
// Copyright 2009 FeliCa Networks, Inc.
// All Rights Reserved.
// FeliCa Networks, Inc. Proprietary/Confidential.
//
package com.felicanetworks.mfc;

/**
 * FeliCaT[oƂ̃ICɊւCxgAIDLpXiC^tF[XłB
 * <p>
 */
oneway interface IFSCEventListener {
    /**
     * FeliCaT[oƂ̃ICŃG[ꍇɌĂяo܂B
     * <p>
     * ̃\bhɓnp[^̓e͈ȉ̒ʂł:
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * <th style="text-align: center;">bZ[W</th>
     * </tr>
     * <tr>
     * <td>FeliCaT[oG[bZ[WMꍇ</td>
     * <td colspan="1" rowspan="4">{@link #TYPE_PROTOCOL_ERROR}</td>
     * <td>G[bZ[W̓e</td>
     * </tr>
     * <tr>
     * <td>FeliCaT[oMbZ[W̃tH[}bgȂꍇ</td>
     * <td>"Packet format error."</td>
     * </tr>
     * <tr>
     * <td>FeliCaT[oMbZ[WԂƓKȂꍇ</td>
     * <td>"Illegal state error."</td>
     * </tr>
     * <tr>
     * <td>FeliCaT[oMʐMp[^Ȃꍇ</td>
     * <td>"Communication initiation error."</td>
     * </tr>
     * <tr>
     * <td>HTTPX|XR[h200ȊȌꍇ</td>
     * <td colspan="1" rowspan="4">{@link #TYPE_HTTP_ERROR}</td>
     * <td>"Invalid response code: <span style="font-style: italic;">X|XR[h
     * </span>"</td>
     * </tr>
     * <tr>
     * <td>HTTPX|X̃Reg^CvȂꍇ</td>
     * <td>"Invalid content-type: <span style="font-style: italic;">Reg^Cv
     * </span>"</td>
     * </tr>
     * <tr>
     * <td>HTTPX|X̃Reg^Cvݒ肳ĂȂꍇ</td>
     * <td>"Invalid content-type: null"</td>
     * </tr>
     * <tr>
     * <td>LȊOHTTPʐMG[ꍇ</td>
     * <td>"HTTP communication error."</td>
     * </tr>
     * <tr>
     * <td>{@link FSC#stop()}̌ĂяoɂFeliCaT[oƂ̃ICfꍇ</td>
     * <td colspan="1" rowspan="2">{@link #TYPE_INTERRUPTED_ERROR}</td>
     * <td colspan="1" rowspan="2">"Interrupted."</td>
     * </tr>
     * <tr>
     * <td>{@link Felica#close()}̌ĂяoɂFeliCaT[oƂ̃ICIꍇ</td>
     * </tr>
     * <tr>
     * <td>{@link #operationRequested(int, String, byte[])}OX[ꍇ</td>
     * <td colspan="1" rowspan="2">{@link #TYPE_UNKNOWN_ERROR}</td>
     * <td colspan="1" rowspan="2">X[ꂽÕbZ[W</td>
     * </tr>
     * <tr>
     * <td><code>FSC</code> ŗOꍇ</td>
     * </tr>
     * </tbody> </table>
     *
     * @param type G[
     * @param message G[bZ[W(bZ[WȂꍇ <code>null</code>)
     */
    void errorOccurred(int type, java.lang.String message);

    /**
     * FeliCaT[oƂ̃ICIꍇɌĂяo܂B
     * <p>
     *
     * @param status Xe[^XR[h
     */
    void finished(int status);

    /**
     * FeliCaT[ofoCXvMꍇɌĂяo܂BΏۂ̃foCX̓foCXIDŎw肳܂B
     * <p>
     * ̃\bhɃ^[ꍇAFeliCaT[oɂ̓foCX쏈ʂnAɍsꂽƂʒm܂B
     * ̃\bhOX[ꂽꍇAFeliCaT[oɂ̓foCX쏈ɍsȂƂʒm܂B
     * <p>
     *
     * @param deviceID foCXID
     * @param param pp[^(p[^Ȃꍇ <code>null</code>)
     * @param data pf[^(f[^Ȃꍇ <code>null</code>)
     * @return foCX쏈
     */
    void operationRequested(int deviceID, java.lang.String param, in byte[] data);
}
